/*
 * HeartRelay2.c
 *
 * Created: 2014/11/04 5:52:40
 *  Author: akira
 */ 

//PB0 Input
//PB2 Output High active

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay_basic.h>
#include <inttypes.h>
uint8_t getAD(void){
	ADCSRA=0xc7;//vXP[1/128 X^[g  1MHz/128/13=600Hz
	while(ADCSRA & 0x40);
	return ADCL;
}
void on(void){
	PORTB|=_BV(PORTB2);	
}
void off(void){
	PORTB&= ~ _BV(PORTB2);
}

int main(void)
{

	DDRB=_BV(PORTB2); //output pin
	ADMUX=0;DIDR0=0x01;//PB0 is adc input
	
	uint16_t ave=0;		
    uint8_t state=0;
	
	while(1)
    {
		uint16_t val=0;
		for(uint8_t c=0;c<8;c++){//67Hz
			val+=getAD();
		}
		
		if(0){//gp
			static uint8_t c=0;
			c++;
			if(c&1)on();
			else off();
			continue;
		}
		
		ave=(19*ave+val)/20;
		
		if(state){
			state--;
		}
		if(state == 0 && ave+10 <val){
			state=30;
		}
		if(20<state)on();
		else off();
		
		
        //TODO:: Please write your application code 
    }
}